/*
 * $Id: soft.h,v 1.5 1998/04/27 18:26:09 kangasha Exp kangasha $
 *
 * AUTHOR: Fabio Carignano
 *
 * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
 * --------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from the
 *  Internet community.  Development is led by Duane Wessels of the
 *  National Laboratory for Applied Network Research and funded by
 *  the National Science Foundation.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 */

#ifndef SOFT_H
#define SOFT_H

#define SOFT_LEVELS 5
#define DEFAULT_RECODERS 5
#define DefaultRecoderChildrenMax 64

#define SOFT_FLAG_ALIVE           0x01
#define SOFT_FLAG_CLOSING         0x02
#define SOFT_FLAG_WRITE_PENDING   0x04
#define SOFT_FLAG_BUSY            0x08

#define REQUEST_FLAG_PENDING      0x01
#define REQUEST_FLAG_WRITTEN      0x02

#define SOFT_COMBUF_SZ (SQUID_MAXPATHLEN + 16)

typedef struct _recoderequest {
    struct _recoderequest *next;
    StoreEntry *e;
    int slices;
    int flags;
    struct timeval dispatched;
} recoderequest_t;

typedef struct _softrecoder {
    int id;
    int flags;
    int inpipe;
    int outpipe;
    FILE *fin;
    int pending;
    int waiting;
    time_t answer;
    struct timeval dispatch_time;
    recoderequest_t *list;
    int completed;
    float avg_servicetime;
    float avg_recodetime;
} softrecoder_t;

struct _softStats {
    int requests;
    int replies;
    int hist[DefaultRecoderChildrenMax];
};

extern void softInit _PARAMS((void));
extern void softClose _PARAMS((void));
extern int softRecode _PARAMS((StoreEntry *, int));
extern void softStats _PARAMS((StoreEntry *));

extern struct _softStats SoftStats;

#endif /* SOFT_H */
